      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   DBGVIEW(@9) OPTIMIZE(@8) OPTION(*EVENTF)
      * ---------------------------------------------------------------
      * Program: T_DYNL               Project.....:
      * Author.: A. Campin            Date written: 12/23/2011
      * Purpose: Test Dynamic Load Service Program.
      * ---------------------------------------------------------------
      * Revision history:
      *  Project # Pgmr        Date   Desc
      *
      * End Revision History
      * ---------------------------------------------------------------
     h Option(*Srcstmt:*Nodebugio)

      /copy *libl/qsrcf,cb_StdType
      /copy *libl/qsrcf,cb_Std_Con

      /copy *libl/qsrcf,xverrh_pr
      /copy *libl/qsrcf,xvldyn_pr

     d ProgramEntrance...
     d                 pr                  ExtPgm('T_DYNL')

     d g_pptrServiceProcedure...
     d                 s                   Like(StdPrcPtr)

     d ProgramEntrance...
     d                 pi

     d ServiceProcedure...
     d                 pr                  ExtProc(g_pptrServiceProcedure)
     d   PR_TestName...
     d                                     Like(StdNam)
     d                                     Value

     d cServiceProgramName...
     d                 c                   'T_SRVP'
     d cServiceProgramLibrary...
     d                 c                   '*LIBL'
     d cServiceProcedureName...
     d                 c                   'TESTSERVICE'

     d MessageId...
     d                 s                   Like(StdMsgId)
     d QMessageFileName...
     d                 s                   Like(StdQNam)
     d MessageData...
     d                 s           1024a   Varying
      /Free

       g_pptrServiceProcedure =
           LDYN_LoadServiceProgramProcedure(cServiceProgramName   :
                                            cServiceProgramLibrary:
                                            cServiceProcedureName );
       If g_pptrServiceProcedure = *Null;
         ERRH_Throw('CPF9898'                             :
                     cCPFMessageFileName                  :
                     'Unable to load service program ' +
                                     cServiceProgramName);
       EndIf;

       Monitor;
         ServiceProcedure('TEST_NAME');
       On-Error *All;
         ERRH_GetLastMessage(MessageId       :
                             QMessageFileName:
                             MessageData     );
         ERRH_Throw(MessageId       :
                    QMessageFileName:
                    MessageData     );
       EndMon;
       *InLR = *On;
       Return;

      /End-Free
